<template>
  <main v-if="useCaseItem" class="page-use-case-item">
    <section class="section">
      <div class="wrapper-title">
        <h1 class="main-title">{{ useCaseItem.title }}</h1>
      </div>
      <div v-if="useCaseItem?.person?.image?.url" class="person-block">
        <div class="person-block-top">
          <img
            :src="img(useCaseItem.person.image.url)"
            :alt="useCaseItem.person.image.alt"
            class="person-image"
          />
          <div>
            <p class="text-name">{{ useCaseItem.person.name }}</p>
            <p class="text-person">{{ useCaseItem.person.job }}</p>
          </div>
        </div>
        <p class="text-person">{{ useCaseItem.person.text }}</p>
      </div>
      <p
        v-if="useCaseItem.introduction"
        v-html="useCaseItem.introduction"
        class="summary-text"
      ></p>
      <div v-if="useCaseItem.image">
        <img
          :src="img(useCaseItem.image.url)"
          :alt="useCaseItem.image.alt"
          class="image"
        />
        <span class="image-description">{{
          useCaseItem.image.description
        }}</span>
      </div>
      <div v-for="item in useCaseItem.blocks">
        <h2 class="title">{{ item.title }}</h2>
        <p v-html="item.text" class="summary-text"></p>
        <div v-if="item.image">
          <img :src="img(item.image.url)" :alt="item.image.alt" class="image" />
          <span class="image-description">{{ item.image.description }}</span>
        </div>
        <p
          v-if="item.text_continuation"
          v-html="item.text_continuation"
          class="summary-text"
        ></p>
        <div v-if="item.image2">
          <img
            :src="img(item.image2.url)"
            :alt="item.image2.alt"
            class="image"
          />
          <span class="image-description">{{ item.image2.description }}</span>
        </div>
        <p v-if="item.text_end" v-html="item.text_end" class="summary-text"></p>
      </div>
      <img
        src="https://media.licdn.com/dms/image/v2/D4E22AQGrMVK2RLzoaw/feedshare-shrink_2048_1536/feedshare-shrink_2048_1536/0/1725265179209?e=1728518400&v=beta&t=wfe7Hj528RHKupsnIdCGDD5YrgIbLTtOdJfzXLs71oM"
        alt=""
        class="image-end"
      />
    </section>
  </main>
</template>

<script lang="ts" setup>
import { watch, onMounted, ref } from 'vue'
import { useI18n } from 'vue-i18n'
import { useRoute } from 'vue-router'
import { img } from '../utils/image'
import { formatBlock, tmWrapper } from '@/utils'
const { t } = useI18n()
const route = useRoute()
let useCaseItem = ref<UseCaseItemData | null>(null)
interface UseCaseBlock {
  title: string
  text: string
  image?: {
    url: string
    alt: string
    description: string
  }
  text_continuation?: string
  text_end?: string
  image2?: {
    url: string
    alt: string
    description: string
  }
}

interface UseCaseItemData {
  id: string
  title: string
  introduction?: string
  blocks: UseCaseBlock[]
  image: {
    url: string
    alt: string
    description: string
  }
  image_end?: {
    url: string
  }
  person: {
    name: string
    job: string
    text: string
    image: {
      url: string
      alt: string
      description: string
    }
  }
}
type UseCaseItems = UseCaseItemData[]
watch(
  () => route.params.id,
  () => updateDatas()
)
onMounted(() => updateDatas())

function formatObject(person: string, img: string) {
  return {
    person: {
      name: t(`${person}.name`),
      job: t(`${person}.job`),
      text: t(`${person}.text`),
      image: {
        url: img,
        alt: t(`${person}.image.alt`),
        description: t(`${person}.image.description`)
      }
    }
  }
}
function updateDatas(): void {
  const datas: UseCaseItems = [
    {
      ...tmWrapper('pages.useCases.useCasesItems.block_panoramax'),
      image: {
        ...tmWrapper('pages.useCases.useCasesItems.block_panoramax.image'),
        url: 'panoramax-article.jpg'
      },
      id: 'au-final-panoramax-ca-sert-a-quoi',
      blocks: formatBlock({
        ...tmWrapper('pages.useCases.useCasesItems.block_panoramax'),
        block_users: {
          ...tmWrapper(
            'pages.useCases.useCasesItems.block_panoramax.block_collaborative'
          ),
          image: {
            ...tmWrapper(
              'pages.useCases.useCasesItems.block_panoramax.block_users.image'
            ),
            url: 'panoramax-article-item1.svg'
          }
        },
        block_utility: {
          ...tmWrapper(
            'pages.useCases.useCasesItems.block_panoramax.block_utility'
          ),
          image: {
            ...tmWrapper(
              'pages.useCases.useCasesItems.block_panoramax.block_utility.image'
            ),
            url: 'panoramax-article-item2.png'
          }
        }
      })
    },
    {
      ...tmWrapper('pages.useCases.useCasesItems.block_valparisis'),
      ...formatObject(
        'pages.useCases.useCasesItems.block_valparisis.person',
        'valparisis-person.jpeg'
      ),
      id: 'l-agglomeration-de-valparisis-pionniere-sur-panoramax',
      blocks: formatBlock({
        ...tmWrapper('pages.useCases.useCasesItems.block_valparisis'),
        block_why: {
          ...tmWrapper(
            'pages.useCases.useCasesItems.block_valparisis.block_why'
          ),
          image: {
            ...tmWrapper(
              'pages.useCases.useCasesItems.block_valparisis.block_why.image'
            ),
            url: 'valparisis-article-item1.jpg'
          },
          image2: {
            ...tmWrapper(
              'pages.useCases.useCasesItems.block_valparisis.block_why.image2'
            ),
            url: 'valparisis-article-item2.jpg'
          }
        }
      })
    },
    {
      ...tmWrapper('pages.useCases.useCasesItems.block_cartesapp'),
      ...formatObject(
        'pages.useCases.useCasesItems.block_cartesapp.person',
        'cartes-app-person.jpeg'
      ),
      image: {
        ...tmWrapper('pages.useCases.useCasesItems.block_cartesapp.image'),
        url: 'cartes-app-article.jpg'
      },
      id: 'cartes-app-1ere-carte-generaliste-a-integrer-panormax',
      blocks: formatBlock({
        ...tmWrapper('pages.useCases.useCasesItems.block_cartesapp')
      })
    },
    {
      ...tmWrapper('pages.useCases.useCasesItems.block_bayonne_generic'),
      ...formatObject(
        'pages.useCases.useCasesItems.block_bayonne_generic.person',
        'bayonne-person.jpg'
      ),
      id: 'bayonne-un-reseau-d-agents-impliques-sur-la-collecte-pour-des-usages-multiples',
      blocks: formatBlock({
        ...tmWrapper('pages.useCases.useCasesItems.block_bayonne_generic'),
        block_collaborative: {
          ...tmWrapper(
            'pages.useCases.useCasesItems.block_bayonne_generic.block_collaborative'
          ),
          image: {
            ...tmWrapper(
              'pages.useCases.useCasesItems.block_bayonne_generic.block_collaborative.image'
            ),
            url: 'bayonne-general-article-item1.jpg'
          }
        },
        block_agent_access: {
          ...tmWrapper(
            'pages.useCases.useCasesItems.block_bayonne_generic.block_agent_access'
          ),
          image: {
            ...tmWrapper(
              'pages.useCases.useCasesItems.block_bayonne_generic.block_agent_access.image'
            ),
            url: 'bayonne-general-article-item2.JPG'
          }
        },
        block_multiple_usecases: {
          ...tmWrapper(
            'pages.useCases.useCasesItems.block_bayonne_generic.block_multiple_usecases'
          ),
          image: {
            ...tmWrapper(
              'pages.useCases.useCasesItems.block_bayonne_generic.block_multiple_usecases.image'
            ),
            url: 'bayonne-general-article-item3.jpg'
          }
        }
      })
    }
  ]
  useCaseItem.value = datas.find((e) => e.id === route.params.id) || null
}
</script>

<style scoped lang="scss">
.page-use-case-item {
  min-height: calc(100vh - 28rem);
}
.section {
  padding: 3rem 15%;
}
.main-title {
  @include title();
  margin-right: 2rem;
}
.wrapper-title {
  display: flex;
  justify-content: space-between;
  align-items: center;
  margin-bottom: 5rem;
}
.title {
  font-size: 1.8rem;
  margin-bottom: 1rem;
  margin-top: 4rem;
}
.summary-text {
  white-space: pre-wrap;
  font-size: 1.6rem;
  line-height: 1.5;
  margin-bottom: 4rem;
  margin-top: 2rem;
  color: var(--grey-dark);
}
.image {
  width: 100%;
}
.image-description {
  font-size: 1.4rem;
  color: var(--grey-dark);
  font-style: italic;
}
.person-block {
  width: fit-content;
  background-color: var(--blue-pale);
  color: var(--blue-dark);
  border-radius: 1rem;
  padding: 2rem;
}
.person-block-top {
  display: flex;
  align-items: center;
  margin-bottom: 2rem;
  &:first-child {
    font-size: 2rem;
  }
}
.person-image {
  height: 8rem;
  width: 8rem;
  border-radius: 50%;
  margin-right: 2rem;
}
.text-person {
  font-size: 1.4rem;
}
.text-name {
  font-weight: bold;
  font-size: 2rem;
  margin-bottom: 0.5rem;
}
.image-end {
  width: 100%;
}
@media (max-width: 1324px) {
  .section {
    padding-right: 10%;
    padding-left: 10%;
  }
}
@media (max-width: 768px) {
  .main-title {
    font-size: 2rem;
  }
  .section {
    padding-right: 2rem;
    padding-left: 2rem;
  }
  .summary-text {
    font-size: 1.4rem;
  }
  .title {
    font-size: 1.6rem;
    margin-bottom: 1rem;
  }
}
@media (max-width: 500px) {
  .person-block-top {
    flex-direction: column;
    align-items: initial;
  }
  .person-image {
    margin-bottom: 1.5rem;
    margin-right: 0;
    width: fit-content;
  }
}
</style>
